using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Runtime.ExceptionServices;
using System.Security.Permissions;
using UnityEngine;
using UnityEngine.Events;


namespace SonicC
{
    public class SonicC
    {
        public static void Main()
        {
 
 
 CategoryBuilder.Create("SonicC", "Sonic Stuff", ModAPI.LoadSprite("category.png"));
 Liquid.Register("AlienBlood", new ablood());
 Liquid.Register("Chaos Water", new cwater());
 Liquid.Register("Hemolymph", new hemolymph());    
	//Sonic
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Sonic The Hedgehog",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Gotta go fast",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("SonicView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("SonicSkin.png");
                        var flesh = ModAPI.LoadTexture("SonicFlesh.png");
                        var bone = ModAPI.LoadTexture("SonicBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
//Shadow
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Shadow The Hedgehog",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "The Ultimate Life-Form",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("ShadowView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("ShadowSkin.png");
                        var flesh = ModAPI.LoadTexture("ShadowFlesh.png");
                        var bone = ModAPI.LoadTexture("SonicBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
//Knuckles
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Knuckles the Echidna",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Do I look like I need your power",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("KnucklesView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("KnucklesSkin.png");
                        var flesh = ModAPI.LoadTexture("KnucklesFlesh.png");
                        var bone = ModAPI.LoadTexture("KnucklesBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );			
//Tails
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Tails The Fox",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "This time Sonic will not help",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("TailsView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("TailsSkin.png");
                        var flesh = ModAPI.LoadTexture("TailsFlesh.png");
                        var bone = ModAPI.LoadTexture("TailsBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );	

//Fox Tail
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "Fox Tail",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "attach manually",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("FoxTailV.png", 1f),
                    AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("FoxTail.png");
            						Instance.FixColliders();
        }
    }
);
//Eggman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Doctor Eggman",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Get a load of this!",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("EggmanView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("EggmanSkin.png");
                        var flesh = ModAPI.LoadTexture("EggmanFlesh.png");
                        var bone = ModAPI.LoadTexture("EggmanBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );	
 //Metal Sonic
	ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
			        NameOverride = "Metal Sonic", //new item name with a suffix to assure it is globally unique
					NameToOrderByOverride = "F0",
			        DescriptionOverride = "Know everything you're going to do", //new item description
			        CategoryOverride = ModAPI.FindCategory("SonicC"), //new item category
			        ThumbnailOverride = ModAPI.LoadSprite("MetalView.png"), //new item thumbnail (relative path)
			        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
			        {
			            //load textures for each layer (see Human textures folder in this repository)
			            var skin = ModAPI.LoadTexture("MetalSonicSkin.png");
			            var flesh = ModAPI.LoadTexture("MetalSonicD.png");
			            var bone = ModAPI.LoadTexture("MetalSonicS.png");

			            //use the helper function to set each texture
			            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin,flesh,bone);
			        }
			    }
			);			
	//Amy Rose
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Amy Rose",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "She has a hammer",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("AmyView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("AmySkin.png");
                        var flesh = ModAPI.LoadTexture("AmyFlesh.png");
                        var bone = ModAPI.LoadTexture("SonicBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
//Hammer
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Hammer"),
                    NameOverride = "Piko Piko Hammer",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Hight Class Weapon",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("AmyHammerV.png", 1f),
                    AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AmyHammer.png");
            var properties = ModAPI.FindPhysicalProperties("Metal");
			
        }
    }
);			
//Hammer
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Power Hammer"),
                    NameOverride = "Piko Piko Power Hammer",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Stronger version of Amy's hammer",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("AmyPHammerV.png", 1f),
                    AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AmyPHammer.png");
            
			
        }
    }
);	
//Cream
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Cream the Rabbit",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "The strongest character",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("CreamView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("CreamSkin.png");
                        var flesh = ModAPI.LoadTexture("CreamFlesh.png");
                        var bone = ModAPI.LoadTexture("CreamBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
//Big The Cat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Big The Cat",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "FROGGY!",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("BigView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("BigSkin.png");
                        var flesh = ModAPI.LoadTexture("BigFlesh.png");
                        var bone = ModAPI.LoadTexture("BigBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );	

//Fishing Rod
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "Big's Fishing Rod",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Everyone's favourite Sonic Adventure minigame",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("BigRodV.png", 1f),
                    AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BigRod.png");
			Instance.FixColliders();
            
			
        }
    }
);		
			
//Chaos
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Chaos",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "You know nothing, fool! It's Chaos! the God Of Destruction.",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("ChaosView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        var skin = ModAPI.LoadTexture("ChaosSkin.png");
                        var flesh = ModAPI.LoadTexture("ChaosFlesh.png");
                        var bone = ModAPI.LoadTexture("ChaosBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(20, 184, 248); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(20, 100, 248); //second bruise colour. red by default
                        person.SetThirdBruiseColor(0, 255, 255); // third bruise colour. light yellow by default
                        person.SetBloodColour(0,200,200); // blood clour. dark red by default
                        person.SetRottenColour(100, 100, 100); // rotten/zombie colour. light yellow/green by default
                
				foreach (LimbBehaviour limb in person.Limbs)
                      {
                         
                         limb.BloodLiquidType = "Chaos Water";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Chaos Water"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      
                  }
              }
            );			
//Silver
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Silver The Hedgehog",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "It's no use!",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("SilverView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("SilverSkin.png");
                        var flesh = ModAPI.LoadTexture("SilverFlesh.png");
                        var bone = ModAPI.LoadTexture("SonicBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
			//Blaze
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Blaze The Cat",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "A cat from another dimension",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("BlazeView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("BlazeSkin.png");
                        var flesh = ModAPI.LoadTexture("BlazeFlesh.png");
                        var bone = ModAPI.LoadTexture("BlazeBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
//Rouge 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Rouge The Bat",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Sneak 100",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("RougeView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("RougeSkin.png");
                        var flesh = ModAPI.LoadTexture("RougeFlesh.png");
                        var bone = ModAPI.LoadTexture("RougeBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );	
	
//Omega
	ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
			        NameOverride = "E-123 Omega", //new item name with a suffix to assure it is globally unique
					NameToOrderByOverride = "F0",
			        DescriptionOverride = "Not as bulky anymore", //new item description
			        CategoryOverride = ModAPI.FindCategory("SonicC"), //new item category
			        ThumbnailOverride = ModAPI.LoadSprite("OmegaView.png"), //new item thumbnail (relative path)
			        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
			        {
			            //load textures for each layer (see Human textures folder in this repository)
			            var skin = ModAPI.LoadTexture("OmegaSkin.png");
			            var flesh = ModAPI.LoadTexture("OmegaD.png");
			            var bone = ModAPI.LoadTexture("OmegaB.png");

			            //use the helper function to set each texture
			            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin,flesh,bone);
			        }
			    }
			);			
//Espio
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Espio the Chameleon",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Sneak 200",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("EspioView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("EspioSkin.png");
                        var flesh = ModAPI.LoadTexture("EspioFlesh.png");
                        var bone = ModAPI.LoadTexture("EspioBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );

//Vecrot
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Vector the Crocodile",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Find the computer room!",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("VectorView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("VectorSkin.png");
                        var flesh = ModAPI.LoadTexture("VectorFlesh.png");
                        var bone = ModAPI.LoadTexture("VectorBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
						var head = Instance.transform.GetChild(5);
                        
						var cObj = new GameObject("visor");
                        cObj.transform.SetParent(head);
                        cObj.transform.localPosition = new Vector3(0.02f, 0.112f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(1f, 1f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("vectorface.png");
                        cSpr.sortingLayerName = "Top";
						
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );	
//Crocodile Tail
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "Crocodile Tail",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "attach manually",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("CrodocideTailV.png", 1f),
                    AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("CrocodileTail.png");
            Instance.FixColliders();
        }
    }
);			

//Charmy
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Charmy Bee",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "May or may not have brain damage",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("CharmyView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        var skin = ModAPI.LoadTexture("CharmySkin.png");
                        var flesh = ModAPI.LoadTexture("CharmyFlesh.png");
                        var bone = ModAPI.LoadTexture("CharmyBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(60, 50, 40); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(220, 200, 120); //second bruise colour. red by default
                        person.SetThirdBruiseColor(255, 230, 160); // third bruise colour. light yellow by default
                        person.SetRottenColour(201, 200, 102); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(220, 195, 90); 
                    foreach (LimbBehaviour limb in person.Limbs)
                      {
                         
                         limb.BloodLiquidType = "Hemolymph";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Hemolymph"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
					}
                }
            );
//Ray
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Ray the Flying Squirrel",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "A Squirrel that can fly or I guess glide",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("RayView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("RaySkin.png");
                        var flesh = ModAPI.LoadTexture("RayFlesh.png");
                        var bone = ModAPI.LoadTexture("RayBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );	
//Ray Tail

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "Squirrel Tail",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "It's a tail I guess",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("SquirrelTailV.png", 1f),
                    AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SquirrelTail.png");
            						Instance.FixColliders();
        }
    }
);	
//Mighty
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Mighty the Armadillo",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Sadly not bulletproof",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("MightyView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("MightySkin.png");
                        var flesh = ModAPI.LoadTexture("MightyFlesh.png");
                        var bone = ModAPI.LoadTexture("MightyBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );			
			
//Maria
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Maria Robotnik",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Can slap anyone to death",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("MariaView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
						
                        var skin = ModAPI.LoadTexture("MariaSkin.png");
                        var flesh = ModAPI.LoadTexture("MariaFlesh.png");
                        var bone = ModAPI.LoadTexture("GunSBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(60, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
						
                    }
                }
            );			
//GUN soldier
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "G.U.N. Soldier",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Catch me later, I'll buy you a beer",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("GS1View.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
						
                        var skin = ModAPI.LoadTexture("GunS1Skin.png");
                        var flesh = ModAPI.LoadTexture("GunSFlesh.png");
                        var bone = ModAPI.LoadTexture("GunSBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
						
                    }
                }
            );
//BlackWarrior
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Black Warrior",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Black Creature",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("BWaView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        var skin = ModAPI.LoadTexture("BaWSkin.png");
                        var flesh = ModAPI.LoadTexture("BaWFlesh.png");
                        var bone = ModAPI.LoadTexture("BaWBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(4, 125, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(4, 110, 4); //second bruise colour. red by default
                        person.SetThirdBruiseColor(0, 255, 100); // third bruise colour. light yellow by default
                        person.SetBloodColour(0,200,4); // blood clour. dark red by default
                        person.SetRottenColour(10, 98, 84); // rotten/zombie colour. light yellow/green by default
                
				foreach (LimbBehaviour limb in person.Limbs)
                      {
                         
                         limb.BloodLiquidType = "AlienBlood";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("AlienBlood"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      
                  }
              }
            );
//BlackDoom
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Black Doom",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "The main antagonist in Shadow the Hedgehog",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("BDoomView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        var skin = ModAPI.LoadTexture("BDoomSkin.png");
                        var flesh = ModAPI.LoadTexture("BDoomFlesh.png");
                        var bone = ModAPI.LoadTexture("BDoomBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(4, 125, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(4, 110, 4); //second bruise colour. red by default
                        person.SetThirdBruiseColor(0, 255, 100); // third bruise colour. light yellow by default
                        person.SetBloodColour(0,200,4); // blood clour. dark red by default
                        person.SetRottenColour(10, 98, 84); // rotten/zombie colour. light yellow/green by default
                
				var head = Instance.transform.GetChild(5);
                        
						var cObj = new GameObject("visor");
                        cObj.transform.SetParent(head);
                        cObj.transform.localPosition = new Vector3(0.02f, 0.112f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(1f, 1f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("Doomhorn.png");
                        cSpr.sortingLayerName = "Top";
				
				foreach (LimbBehaviour limb in person.Limbs)
                      {
                         
                         limb.BloodLiquidType = "AlienBlood";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("AlienBlood"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      
                  }
              }
            );			
			
//Shadow Android
	ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
			        NameOverride = "Shadow Android", //new item name with a suffix to assure it is globally unique
					NameToOrderByOverride = "F0",
			        DescriptionOverride = "The actual fake hedgehog", //new item description
			        CategoryOverride = ModAPI.FindCategory("SonicC"), //new item category
			        ThumbnailOverride = ModAPI.LoadSprite("ShadowAView.png"), //new item thumbnail (relative path)
			        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
			        {
			            //load textures for each layer (see Human textures folder in this repository)
			            var skin = ModAPI.LoadTexture("ShadowSkin.png");
			            var flesh = ModAPI.LoadTexture("MetalSonicD.png");
			            var bone = ModAPI.LoadTexture("MetalSonicS.png");

			            //use the helper function to set each texture
			            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin,flesh,bone);
			        }
			    }
			);
//Jet

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Jet The Hawk",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Leader of Babylon Rogues",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("JetView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("JetSkin.png");
                        var flesh = ModAPI.LoadTexture("JetFlesh.png");
                        var bone = ModAPI.LoadTexture("JetBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );		
//Wave

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Wave the Swallow",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Purple Bird",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("WaveView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("WaveSkin.png");
                        var flesh = ModAPI.LoadTexture("WaveFlesh.png");
                        var bone = ModAPI.LoadTexture("WaveBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );

//Storm

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Storm the Albatross",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("StormView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("StormSkin.png");
                        var flesh = ModAPI.LoadTexture("StormFlesh.png");
                        var bone = ModAPI.LoadTexture("StormBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );					


		
		//Chaos Emerald	
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Chaos Emerald",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "It all starts with this",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("ChaosEmeralds/emeralds.png"),
                    AfterSpawn = (Instance) =>
                    {
 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ChaosEmeralds/g.png");

                        Instance.GetOrAddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("ChaosEmeralds/r.png"),
                            ModAPI.LoadSprite("ChaosEmeralds/b.png"),
                            ModAPI.LoadSprite("ChaosEmeralds/g.png"),
                            ModAPI.LoadSprite("ChaosEmeralds/w.png"),
                            ModAPI.LoadSprite("ChaosEmeralds/c.png"),
							ModAPI.LoadSprite("ChaosEmeralds/y.png"),
							ModAPI.LoadSprite("ChaosEmeralds/p.png")
                        };

                        Instance.FixColliders();
                    }
                }
            );
			
		//Ring
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Ring",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("RingView.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Ring.png");
						Instance.FixColliders();
                    }
					
                }
            );
			
			
			//Super Sonic
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Super Sonic",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Gotta go faster",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("SuperSonicView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("SuperSonicSkin.png");
                        var flesh = ModAPI.LoadTexture("SonicFlesh.png");
                        var bone = ModAPI.LoadTexture("SonicBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
		//Super Shadow
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Super Shadow",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "The Ultimate Life-Form",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("SuperShadowView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("SuperShadowSkin.png");
                        var flesh = ModAPI.LoadTexture("ShadowFlesh.png");
                        var bone = ModAPI.LoadTexture("SonicBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
//Super Silver
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Super Silver",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "It's no use",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("SuperSilverView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("SuperSilverSkin.png");
                        var flesh = ModAPI.LoadTexture("SilverFlesh.png");
                        var bone = ModAPI.LoadTexture("SonicBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
			
			//Shadow Rifle
ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
    NameOverride = "Shadow Rifle",
    DescriptionOverride = "Death to all who oppose me",
    CategoryOverride = ModAPI.FindCategory("SonicC"),
    NameToOrderByOverride = "F0",
    ThumbnailOverride = ModAPI.LoadSprite("SRV.png"),
    AfterSpawn = (Instance) =>
    {

        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shrifle2.png");
        foreach (var c in Instance.GetComponents<Collider2D>())
        {
            GameObject.Destroy(c);
        }
        Instance.FixColliders();
		Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

        var firearm = Instance.GetComponent<FirearmBehaviour>();
       
        Cartridge customCartridge = ModAPI.FindCartridge("30 mm");
        customCartridge.name = "30 mm";
        customCartridge.Damage *= 2.0f;
        customCartridge.StartSpeed *= 1.5f;
        customCartridge.PenetrationRandomAngleMultiplier *= 0.6f;
        customCartridge.Recoil *= 0.1f;
        customCartridge.ImpactForce *= 2.0f;
        firearm.Cartridge = customCartridge;

        Instance.FixColliders();
}
}
);			
			
//Murasama
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "HF Murasama",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Wait wrong game",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("MurasamaView.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("murasama.png");
                    }
                }
            );
			

			
//Photoshop Sonic
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Photoshop Disaster Sonic",
                    NameToOrderByOverride = "F0",
                    DescriptionOverride = "Crime agains nature",
                    CategoryOverride = ModAPI.FindCategory("SonicC"),
                    ThumbnailOverride = ModAPI.LoadSprite("Sawnek.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("PSonic.png");
                        var flesh = ModAPI.LoadTexture("PSonicF.png");
                        var bone = ModAPI.LoadTexture("PSonicB.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 4);
                        person.SetBruiseColor(200, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(100, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
			
}}
//blood stuff
public class ablood : Liquid
{
    public ablood()
    {
        this.Color = new Color32(10, 200, 10, 255);
    }

    public override void OnEnterContainer(BloodContainer container)
    {
    }

    public override void OnEnterLimb(LimbBehaviour limb)
    {
        if (limb.SpeciesIdentity == "Android" && UnityEngine.Random.value > 0.995f)
        {
            limb.PhysicalBehaviour.Charge += 0.1f;
        }
    }

    public override void OnExitContainer(BloodContainer container)
    {
    }

    public const string ID = "AlienBlood";
}
//chaoswater
public class cwater : Liquid
{
    public cwater()
    {
        this.Color = new Color32(99, 149, 189, 100);
    }

    public override void OnEnterContainer(BloodContainer container)
    {
    }

    public override void OnEnterLimb(LimbBehaviour limb)
    {
        if (limb.SpeciesIdentity == "Android" && UnityEngine.Random.value > 0.995f)
        {
            limb.PhysicalBehaviour.Charge += 0.1f;
        }
    }

    public override void OnExitContainer(BloodContainer container)
    {
    }

    public const string ID = "Chaos Water";
}
public class hemolymph : Liquid
{
    public hemolymph()
    {
        this.Color = new Color32(220, 195, 90, 255);
    }

    public override void OnEnterContainer(BloodContainer container)
    {
    }

    public override void OnEnterLimb(LimbBehaviour limb)
    {
        if (limb.SpeciesIdentity == "Android" && UnityEngine.Random.value > 0.995f)
        {
            limb.PhysicalBehaviour.Charge += 0.1f;
        }
    }

    public override void OnExitContainer(BloodContainer container)
    {
    }

    public const string ID = "Hemolymph";
}
}